Bug 1874931 - Accessibility - Keyboard shortcut to exit YAML editor not easily discoverable
Summary: Accessibility - Keyboard shortcut to exit YAML editor not easily discoverable
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Management Console
Version: 4.6
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: ---
: 4.8.0
Assignee: Steve Goodwin
QA Contact: Yadan Pei
URL:
Whiteboard: Accessibility
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-09-02 15:27 UTC by Cyril
Modified: 2021-07-27 22:33 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Cause: User is navigating via keyboard only, they become “tab trapped” within the YAML editor Consequence: A "View shortcuts" popover outside the editor contains Accessibility help. User cannot exit the editor to access those keyboard shortcuts. Fix: Display ⌥ Opt + F1 keystrokes to access Accessibility help above the editor. Additional shortcuts added to popover. `View all editor shortcuts`, `Accessibility help` and `Toggle Tab action between insert Tab character and move focus out of editor` Result: Keyboard only users can more easily access Accessibility help within the editor
Clone Of:
Environment:
Last Closed: 2021-07-27 22:32:55 UTC
Target Upstream Version:


Attachments (Terms of Use)
Yaml editor (120.89 KB, image/png)
2020-09-02 15:27 UTC, Cyril
no flags Details
new added shortcuts (63.65 KB, image/png)
2021-02-18 06:02 UTC, Yadan Pei
no flags Details


Links
System ID Private Priority Status Summary Last Updated
Github openshift console pull 8115 0 None closed Bug 1874931: Add shortcut above YAML editor and tab toggle action shortcut to popover to improve accessibility 2021-02-18 03:46:05 UTC
Red Hat Product Errata RHSA-2021:2438 0 None None None 2021-07-27 22:33:19 UTC

Description Cyril 2020-09-02 15:27:06 UTC
Created attachment 1713468 [details]
Yaml editor

Description of problem:
Non-compliance: Code editors are used extensively throughout the OCP interface and generally result in keyboard traps when encountered -- there are no keyboard methods for a user to change focus to outside the editor(s) and tabs, escape, and other key sequences appear to be captured by the editor


Version-Release number of selected component (if applicable):
4.6.0-0.nightly-2020-08-02-134243

How reproducible:
Always


Steps to Reproduce:
1. Goto YAML editor and keypress tab. 
2. Try to change focus to outside the editor i.e. Escape key


Actual results:
There are no keyboard controls for a user to change focus to outside the editor

Expected results:
Should have keyboard controls for a user to change focus to outside the editor


Additional info:

Comment 1 Samuel Padgett 2020-09-03 12:56:16 UTC
Note: It is possible to tab out, although I don't think it's easily discoverable.

https://github.com/microsoft/monaco-editor/wiki/Monaco-Editor-Accessibility-Guide#tab-trapping

Option-F1 on Mac shows a popup with accessibility help. There must be a similar shortcut on other platforms. I think we just need to advertise this keybinding somehow and we're probably compliant.

Comment 3 Jakub Hadvig 2020-10-02 15:26:10 UTC
Did not have time for further investigation. Will fix next sprint.

Comment 4 Megan Hall 2020-10-02 16:31:08 UTC
Design Story, https://issues.redhat.com/browse/PD-598

Proposed design solution, https://docs.google.com/document/d/1493j-uxJU-lrlOVTZ72MFey4qlk8G3pvW8otWwpR7I8/edit#
1. add 3 shortcuts to the popover: accessibility help, leave editor focus, view all editor shortcuts
2. when 'entering' the editor, show shortcuts for accessibility help and leave editor focus in labels next to the view shortcuts text link and hide the shortcuts once users 'exit' the editor

Comment 5 Harish Govindarajulu 2020-10-23 19:39:48 UTC
Did not have time for further investigation. Will fix the next sprint.

Comment 6 Harish Govindarajulu 2020-11-13 14:32:56 UTC
Created a story: https://issues.redhat.com/browse/CONSOLE-2468?filter=-2 to rewrite project dropdown component which would fix this issue

Comment 9 Yadan Pei 2021-02-18 06:01:57 UTC
1. Goto YAML editor and add some strings, we can see `Accessibility help` shortcut is added, clicking it will open a popover showing help info about accessibility info.
2. 3 shortcuts are added `View all editor shortcuts`, `Accessibility help`  and `Toggle Tab action between insert Tab character and move focus out of editor`, pressing Ctrl + Shift + M will toggle between insert Tab and move focus out of editor

I think this implementation is working as expected now.

Verified on 4.8.0-0.nightly-2021-02-18-001523

Comment 10 Yadan Pei 2021-02-18 06:02:52 UTC
Created attachment 1757726 [details]
new added shortcuts

Comment 13 errata-xmlrpc 2021-07-27 22:32:55 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (Moderate: OpenShift Container Platform 4.8.2 bug fix and security update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2021:2438


Note You need to log in before you can comment on or make changes to this bug.